#include "mcc_generated_files/mcc.h"
#include "sin_data.h"

// g[hp萔
#define     sin_halfT       120         // 1/2̃f[^
#define     sin_fullT       240         // 1̃f[^
#define     pwm_step_max    256         // PWM1̃Xebv
#define		T1INTmax        2080        // ^C}1荞ݎ̍Œ

//O[oϐ
uint16_t        pwm_step = 0;           // PWM̒ʗpJE^
uint8_t         sin_step = 0;           // gf[^̔ԒnJE^
adc_result_t    ad_out;                 // A-Dϊ

void TMR1_DefaultInterruptHandler(void)
{
    uint16_t        Int_Data, Duty;
    
    RC3 = 1;                            // |[gCRC3(7ԃs)1o͂D荞ݔ̃j^Op

    ad_out = ADC_GetConversion(0x06);   // A-Dϊʂ̎擾
    
    // g[h
    if((RC0 == 0) && (RA2 == 0)) 
    {
        Int_Data = 0xFFFF - (T1INTmax - ad_out*2);	// T1INŤ
        
        TMR1_WriteTimer(Int_Data);      // ^C}1̃JEgAbvl̐ݒDI[ot[Ċ荞݂𔭐
                                        // PWMgfPWM = 32MHz/(TINTmax - ad_out*2)/256 = 60Hz(min) 
                                        // ggfsin = 60Hz/sin_div/2 = 60Hz/240 = 0.25Hz(min) @ۂ͖0.18Hz(min)
                                        // 덷̍őv́CADC_GetConvesion()̏ԂfPWM̌vZɓĂȂ߁D
        Duty = sin_data[sin_step];      // gf[^ɂf[eB䌈
	    
        if(pwm_step <= Duty)            // PWMg`
        {
           if(sin_step < sin_halfT)     // ̔g
           {
                RA5 = 1;                // 2ԃs
            }else{                      // ̔g
                RC5 = 1;                // 5ԃs
            }
        }else{
            RA5 = 0;
            RC5 = 0;
        }
   
        pwm_step = (pwm_step + 1) % pwm_step_max;    // pwm_step +1  (0  pwm_step < pwm_step_max)
		
        if(pwm_step == 0)                           
        {
            sin_step = (sin_step + 1) % sin_fullT;  // sin_step + 1  (0  sin_step < sin_fullT)
    	}

    }
    // PWM[h
    else if((RC0 == 0) && (RA2 == 1))   
    {   	
        TMR1_WriteTimer(0x0);           // ^C}1̃JEgAbvl̐ݒDI[ot[Ŋ荞݂𔭐
                                        // f1INT = 32MHz/(0xFFFF+) = 500Hz
                                        // fPWM500Hz/1024 = 0.5Hz 
    	if(pwm_step <= ad_out)
		{
            RA4 = 1;                    // 3ԃs
        }else{
            RA4 = 0;
        }
    
        pwm_step = (pwm_step + 1) % 1024;  // PWMXebv +1   (0  pwm_step < 1024)
    }
    
    RC3 = 0;                            // |[gCRC3(7ԃs)0o͂D荞ݔ̃j^Op
}

//[^hCu&DAvpPWM[h
void TMR2_DefaultInterruptHandler(void)
{
    RC3 = 1;                            // |[gCRC3(7ԃs)1o͂D荞ݔ̃j^Op

    ad_out = ADC_GetConversion(0x06);   // A-Dϊʂ̎擾

    EPWM2_LoadDutyValue(ad_out);        // PWMf[eB̐ݒ

    RC3 = 0;                            // |[gCRC3(7ԃs)0o͂D荞ݔ̃j^Op
}


void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    while (1)
    {
        // Add your application code
    }
}
/**
 End of File
*/